<template>
  <canvas id="chart"></canvas>
</template>

<script>
import Chart from "chart.js";

export default {
  name: "PieChart",
  props: {
    dataSet: Array,
    labelSet: Array
  },
  methods: {
    randomVal: function (min, max) {
      return Math.floor(Math.random() * (max - min) + 1) + min;
    },

    generateColors: function() {
      let colors = [];
      for (var i = 0; i < this.dataSet.length; i++) {
        let hsl = "hsl(" + this.randomVal(270, 360) + ", " + this.randomVal(30, 95) + "%, " + this.randomVal(30, 80) + "%)";
        colors.push(hsl);
      }
      return colors;
    }
  },
  mounted: function() {
    let canvas = document.getElementById("chart");
    let colors = this.generateColors();

    new Chart(canvas, {
      type: "pie",
      data: {
        labels: this.labelSet,
        datasets: [
          {
            data: this.dataSet,
            backgroundColor: colors
          }
        ]
      }
    });
  }
};
</script>
